*==========================================================================================
* ......: Admin_Sql_Exec_ADO.prg
* ........: AppSQLExecADOBackUpRestore()
*==========================================================================================
PROCEDURE AppSQLExecADOBackUpRestore
LPARAMETERS _tcServer, _tcBase, _tcUser, _tcPass, _tcCommand
*==========================================================================================
* .......:
*==========================================================================================
* ......: _tcServer       -  
*                  _tcBase         -  
*                  _tcUser         -   ( )
*                  _tcPass         - 
*                  _tcCommand      -    
*------------------------------------------------------------------------------------------
* .....:
*==========================================================================================
* .......:   06.12.2006
* ....:
*==========================================================================================
LOCAL _loCon AS ADODB.CONNECTION, _loRs AS ADODB.Recordset

*   
_lcOldError = ON("ERROR")
* 
ON ERROR *
*  
_loCon = CREATEOBJECT("ADODB.Connection")
IF VARTYPE(_loCon) != "O" OR ISNULL(_loCon)
	MESSAGEBOX("    ADO " + CHR(13), 16, "!")
	*   
	ON ERROR &_lcOldError
	* 
	RETURN .F.
ENDIF
_loCon.ConnectionTimeout = 0  &&      ...

*   OLEDB 
_loCon.OPEN("Provider=SQLOLEDB.1; Persist Security Info=False;" ;
         +"SERVER="+_tcServer+"; DATABASE="+_tcBase+"; UID="+_tcUser+"; PWD="+_tcPass)

IF _loCon.State = 0  &&    

	*  
	DO ErrHand WITH "     ."

	ON ERROR &_lcOldError			&&   
	RETURN .F.
ELSE
	*  

	*    
	ON ERROR DO ErrHand WITH ""
	*    
	
	*   ,          
	*        %  STATS
	ActTherm('     - ' + _tcBase, '', 0,", ...")

	*  
	_lnRecords = 0
	_loRS = _loCon.Execute(_tcCommand)

	IF TYPE("_loRS") = 'O'
		LOCAL _i, _lnPosition, _lcTxtMsg
		*    
		DO WHILE NOT ISNULL(_loRS)
			FOR _i = 0 TO _loCon.Errors.COUNT - 1
			    *   
				_lcTxtMsg = _loCon.Errors.ITEM(_i).DESCRIPTION
                
                *    
				
				*  SQL 2000   "percent backed up."
				*  SQL 2005   "percent processed."
				_lnPosition = AT(" percent processed.", _lcTxtMsg)
				IF EMPTY(_lnPosition)
					_lnPosition = AT(" percent backed up.", _lcTxtMsg)
				ENDIF
				IF _lnPosition > 0
					*   
					UpdTherm(VAL(LEFT(_lcTxtMsg, _lnPosition)), ;
						LEFT(_lcTxtMsg, _lnPosition) + "% ")
				ENDIF
			NEXT
			_loRS = _loRS.NextRecordset()
		ENDDO
	ENDIF
	_loCon.CLOSE()	&&  
	*   
	DeactThermo()
ENDIF

*   
ON ERROR &_lcOldError
RETURN .T.

*==========================================================================================
* ......: Admin_Sql_Exec_ADO_New.prg
* ........: ErrHand()
*==========================================================================================
PROCEDURE ErrHand
LPARAMETERS _tcTextMessage
*==========================================================================================
* .......:  
*==========================================================================================
* ......: _tcTextMessage -      
*------------------------------------------------------------------------------------------
* .....:   
*==========================================================================================
* .......:   06.12.2006
* ....:
*==========================================================================================
LOCAL _laError[1]
AERROR(_laError)
*  
MESSAGEBOX(IIF(EMPTY(_tcTextMessage), "", _tcTextMessage + CHR(13));
	+ " :  " + ALLTRIM(STR(_laError[1])) + CHR(13);
	+ " :   " + _laError[3] + CHR(13) ;
	+ ":              " + _laError[4], 16, "!")
ENDPROC

